;(function($){
    var firstLoad = 0, childUwid = [];
    var curIndex,isCheck=0,bound = 60;
    $.commFun = ({
        init:function(){ //组件初始化
            init();
        },
        fixPageHeight:function(){ //重置页面元素高度
            fixPageHeight();
        },
        windowSizeSwiper:function(){ //浏览器窗口尺寸改变时，重置swiper
            windowSizeSwiper();
        },
        setFirstLoad:function(v){ //重置firstLoad的值
            firstLoad = v; //表示程序点开词条并载入后，需要继续跳转页面
        },
        resizeSwiper:function(tabBar,noCurPage){ //重置滑动组件尺寸
            resizeSwiper(tabBar,noCurPage);
        },
        jumpToAim:function(aim){ //根据 对象 页面内跳转
            jumpToAim(aim);
        },
        erClickEvent:function(e){ //ext 标签点击事件
            erClickEvent.call(this,e);
        },
        sentClickEvent:function(e){ //sent 标签点击事件
            sentClickEvent.call(this,e);
        },
        settingRefresh:function(jsonData){ //完成设置后刷新界面方法
            settingRefresh(jsonData);
        },
        commSettingRefresh:function(jsonData){ //多页面公共设置刷新界面方法
            commSettingRefresh(jsonData);
        },
        testActiveTag:function(){ //检测当前用户在浏览那个tag
            return testActiveTag();
        },
        refreshPingfen:function(key, score){ //更新评分模块的分数
            refreshPingfen(key, score);
        },
        refreshStarIconStatus:function(uwid,in_scb){
            refreshStarIconStatus(uwid,in_scb);
        },
        updateAllStarIconStatus:function(jsonD){
            updateAllStarIconStatus(jsonD);
        },
        refreshEvaIcon:function(uwid,score){ //更新单个评测按钮状态
            refreshEvaIcon(uwid,score);
        },

    });

    //更新单个评测按钮状态方法
    function refreshEvaIcon(uwid,score){
        var parent = $(".evaluating");
        var ls = parent.find('.listenSound');
        var es = parent.find('.evaluatingScore');
        if(score > -1){
            ls.removeClass('hidden');
            es.removeClass('hidden');
            es.html(score);
        }
        else {
            ls.addClass('hidden');
            es.addClass('hidden');
        }
    }
    //初始化
    init();
    function init(){
        $('.children').each(function(){
            childUwid.push($(this).attr('uwid'));
        });
        $('.tabBar').each(function(){
            // tabBarClick(this);
            $(this).on("click",function(e){
                e.stopPropagation();
                tabBarClick(this);
            });
        });
    }

    //标签栏点击事件
    function tabBarClick(This){
        var $This = $(This);
        var parent = $This.parent();
        // $This.next().toggle();
        // $This.children(".hideExpSenBtn").toggle();
        // $This.children(".tabName").children("after").toggle();
        // $(".sense-layout").toggle();
        // $(".hideExpSenBtn").toggle();
        parent.toggleClass('show');
        // $.commFun.resizeSwiper($This);
    }

    //更新单个收藏按钮状态
    function refreshStarIconStatus(uwid,in_scb){
        var star = $("[uwid='"+uwid+"']").find('.addStar');
        if(in_scb == '1'){
            star.addClass('inscb');
            pageState.scbStatus[uwid] = 1;
        }
        else if(in_scb == '0') {
            star.removeClass('inscb');
            pageState.scbStatus[uwid] = 0;
        }
    }
    //刷新全部收藏按钮状态*（反向遍历）
    function updateAllStarIconStatus(jsonD){
        $.each(jsonD,function(k,v){
            var nowState = pageState.scbStatus[k];
            if((v==1 || v==0) && (nowState == 1 || nowState == 0) && v != nowState){
                var $addStar = $("[uwid='"+k+"']").find(".addStar");
                pageState.scbStatus[k] = v;
                if(v == 1){
                    $addStar.addClass('inscb');
                }
                else if(v == 0){
                    $addStar.removeClass('inscb');
                }
            }
        });
    }
    //浏览器是否滑动到页面底部
    function scrollBottom(){
        if(document.documentElement.scrollHeight <= document.body.scrollTop + document.documentElement.clientHeight){
            return true;
        }
        return false;
    }
    //重置滑动组件尺寸
    function resizeSwiper(tabBar,noCurPage){
        var swiperPages = pubArgu.swiperPages, swiperMain = pubArgu.swiperMain, swiperBody = pubArgu.swiperBody;
        if(tabBar){ //仅重置tabBar元素所在swiper的尺寸
            if(!tabBar.length) return;
            //重置tabBar父容器swiper尺寸
            var height = tabBar.closest('.content').height();
            var slide = tabBar.parents('.swiper-slide');
            slide.eq(0).css('height', height);
            var s,startIndex;
            if(swiperBody.width){
                var index = slide.eq(1).index();
                s = swiperPages[index];
                startIndex = swiperBody.activeIndex;
                if(index != startIndex){
                    swiperBody.slideTo(index, 0, false);
                    noCurPage = 1;
                }
            }
            else {
                s = swiperMain;
            }
            s.onResize();
            s.update();
            // var btmLine = height * -1 + s.height;
            // s.params.btmLine = btmLine<0 ? btmLine : 0;
            s.params.btmLine = s.maxTranslate();
            if(swiperBody.width && noCurPage){
                swiperBody.slideTo(startIndex, 0, false);
            }
        }
        else{
            //重置整个页面swiper尺寸
            pubArgu.headHeight = -1*$('#header').height() || 0;
            var slide = swiperMain.slides[0];
            var conHei = $(slide).children().height();
            $(slide).css('height', conHei);
            swiperMain.onResize();
            // var btmLine = conHei * -1 + pubArgu.windowHeight;
            // swiperMain.params.btmLine = btmLine < 0 ? btmLine : 0;
            swiperMain.params.btmLine = swiperMain.maxTranslate();
            if(swiperBody.width){
                var i, len = swiperPages.length, height = [];
                pubArgu.headHeight = -1*$('#header').height();
                for(i=0; i<len; i++){
                    var hei = $(swiperPages[i].slides[0]).children().height();
                    height.push(hei);
                }
                for(i=0; i<len; i++){
                    var s = swiperPages[i];
                    $(s.slides[0]).css('height', height[i]);
                    s.onResize();
                    // var btmLine = height[i] * -1 + s.height;
                    // s.params.btmLine = btmLine<0 ? btmLine : 0;
                    s.params.btmLine = s.maxTranslate();
                }
            }
        }
    }
    
    
    //根据 对象 页面内跳转
    function jumpToAim(aim,offdis){
        if(!aim.length) return;
        offdis = offdis || 50;
        var dis = aim.offset().top;
        $(window).scrollTop(dis - offdis);
        // var swiperPages = pubArgu.swiperPages, swiperMain = pubArgu.swiperMain, swiperBody = pubArgu.swiperBody, headHeight = pubArgu.headHeight;
        // if(swiperBody.width){
        //     var id = aim.parents('.swiper-slide').eq(1).index();
        //     swiperBody.slideTo(id, 0, true);
        //     dis = (dis - offdis - swiperPages[id].getWrapperTranslate() -swiperMain.getWrapperTranslate())* -1;
        //     if(dis > 0){
        //         dis = 0;
        //     }
        //     var btmLine = swiperPages[id].params.btmLine;
        //     if(dis >= headHeight){
        //         swiperMain.setWrapperTranslate(dis);
        //     }
        //     if(dis < headHeight) {
        //         if(dis-headHeight > btmLine){
        //             swiperMain.setWrapperTranslate(headHeight);
        //             swiperPages[id].setWrapperTranslate(dis - headHeight);
        //         }
        //         else {
        //             swiperMain.setWrapperTranslate(headHeight);
        //             swiperPages[id].setWrapperTranslate(btmLine);
        //         }
        //     }
        // }
        // else if(swiperMain.width){
        //     dis = (dis - swiperMain.getWrapperTranslate() -offdis)* -1;
        //     if(dis > 0){
        //         dis = 0;
        //     }
        //     var btmLine = swiperMain.params.btmLine;
        //     dis = dis<btmLine ? btmLine : dis;
        //     swiperMain.setWrapperTranslate(dis);
        // }
    }
    //er 标签点击事件
    function erClickEvent(e){
        e.stopPropagation();
        var I = $(this);
        var uwid = I.attr('subuwid');
        var senseId = I.attr('index');
        var pinyin = I.attr('pinyin');
        if(isChildUwid(uwid)){
            extArgu = {"senseId":senseId};
            auto_uwid = [uwid];
            $.jumpPosition.jumpProcedure();
        }
        else if(uwid == pageID){
            extArgu = {"senseId":senseId, "pinyin":pinyin};
            $.jumpPosition.jumpProcedure();
        }
        else {
            searchText({"uwid": uwid, "senseId": senseId, "pinyin": pinyin});
        }
    }
    //sent 标签点击事件
    function sentClickEvent(e){
        e.stopPropagation();
        var uwid = $(this).attr('subuwid');
        if(isChildUwid(uwid)){
            childrenJump(uwid); //跳转到对应的词组
        }
        else {
            searchText({"uwid": uwid});
        }
    }

    //判断uwid是否是词组uwid
    function isChildUwid(uwid){
        for(var i = 0,len = childUwid.length; i<len; i++){
            if(childUwid[i] == uwid){
                return 1;
            }
        }
        return 0;
    }

    //完成设置后刷新界面方法
    function settingRefresh(jsonData){
        commSettingRefresh(jsonData); //多页面公共设置刷新界面方法
    }

    //多页面公共设置刷新界面方法
    function commSettingRefresh(jsonData){
        var fontSize = jsonData.fontSize;
        var style_type = jsonData.style_type;
        var showTilde = jsonData.showTilde;
        if(style_type && style_type != pageState.style_type){
             refreshWebView(); //重刷页面
             return;
        }
        if(fontSize && fontSize != pageState.fontSize){
            $('html').css('font-size',fontSize+"px");
            // resizeSwiper();
            pageState.fontSize = fontSize;
        }
        if((showTilde == "1" || showTilde == "0") && showTilde != pageState.showTilde){
            if(!$.searchText.isSerTextIng()){
                if(showTilde == "1"){
                    $(".main").addClass("showTilde");
                }
                else {
                    $(".main").removeClass("showTilde");
                }
            }
            // resizeSwiper();
            pageState.showTilde = showTilde;
        }
    }

    //重置页面元素高度
    function fixPageHeight(){
        pubArgu.windowWidth = document.documentElement.clientWidth;
        pubArgu.windowHeight = document.documentElement.clientHeight;
        // $('#swiperMain').css('height', pubArgu.windowHeight);
        // $('.swiperPages').css('height', pubArgu.windowHeight - pubArgu.tagBarHeight);
    }

    //浏览器窗口尺寸改变时，重置swiper
    function windowSizeSwiper(){
        fixPageHeight();
        // resizeSwiper();
    }

    //检测当前用户在浏览那个tag
    var $tabBar = $('.tabBar');
    function testActiveTag(){
        for(var i=1,len = $tabBar.length; i<len; i++){
            var top = $('.tabBar')[i].getBoundingClientRect().top;
            if(top > bound){
                if(curIndex != i-1){
                    curIndex = i-1;
                }
                isCheck = 1;
                break;
            }
        }
        if(!isCheck){
            if(curIndex != len-1){
                curIndex = len-1;
            }
        }
        isCheck = 0;
        return curIndex;
    }

    //更新评分模块的分数
    function refreshPingfen(key, score){
        var $key = $(".pingfen-table").find("." + key);
        var $score = $key.find(".score");
        if($score.length){
            $score.html(score + "分");
        }
        else {
            $key.append('<span class="score">'+ score +'分</span>');
        }
    }
    
})(Zepto);