var captureTextMode = false;

(function (){

/*watch long Press*/
/*touch event*/
var g_eventRangeTarget = null;
var g_eventRangeOffset = null;

/*dict search event*/
var g_popupDictTarget = null;
var g_popupDictOffset = null;
var g_popupDictSearch = null;

var g_highLightColor = null;
var g_highLightBackground = '#CCC';

var g_highLightPosX = null;
var g_highLightPosY = null;

var g_highLighter = null;
/*touch position*/
var clientX = 0, clientY = 0;


function isCJK(str){
	var re = /[\u1100-\u11f9\u3041-\u30ff\u3104-\u312a\u3130-\u318e\u3400-\u4db5\u4e00-\u9fa5\uac00-\ud7a3\uf900-\ufa2c\uff66-\uff9e\ud840-\ud869\udc00-\udfff\ue000-\ue849\uf001-\uf070\uf0A0-\uf1D2]/; 
	if(re.test(str)) return true;
	return false; 
}


function isEng(str){
	var re = /[0-9a-zA-Z-]/;
	if(re.test(str)) return true;
	return false; 
}


function isEngChar(str){
	var code = str.charCodeAt(0);
	if(code<383 || (code>61830 && code<61859) || code==61959 || code==62000 || code==62105 || (code>62159 && code<62166)) return true;
	return false;
}

//判断字符串是否以某个词结尾
String.prototype.endWith = function(word){
	var pos = this.length - word.length;
	return (pos>=0 && this.lastIndexOf(word)==pos);
};


function getCharType(str){
	if(str.charCodeAt(0) < 255){
		var n = str.charCodeAt(0);
		if( n >= 97 && n <= 122 ){ // a-z
			return 91;
		}else if ( n >= 65 && n <= 90 ){ // A-Z
			return 61;
		}else if ( n >= 48 && n <= 57 ){ // 0-9
			return 51;
		}else if ( n == 45 ){ // -
			return 45;
		}else if ( n == 32 ){ // space
			return 12;
		}else{
			return 22;
		}
	}else if(isCJK(str)){ // chinese
		return 101;
	}else{
		return 1;
	}

}


var prev_box = null;
var next_box = null;
var prev_out_box = false;
var next_out_box = false;
var last_target = null;
var last_offset = null;
var adjust_offset = 0;
function captureWords(){
	var changed = false;
	if( last_target == g_eventRangeTarget && last_offset == g_eventRangeOffset ){
		if(prev_box !== null){
			if(prev_out_box){
				if(clientX <= prev_box.maxX || clientY >= prev_box.minY || ((prev_box.maxY || prev_box.maxY === 0) && (clientY <= prev_box.maxY || clientX >= prev_box.left))){
					changed = true;
				}
			}else{
				if(clientX > prev_box.maxX || clientY < prev_box.minY || ((prev_box.maxY || prev_box.maxY === 0) && (clientY > prev_box.maxY || clientX < prev_box.left))){
					changed = true;
				}else {
					if(prev_box.minX > 0){
						if(clientX < prev_box.minX){
							changed = true;
						}
					}else{
						if(clientX >= -prev_box.minX){
							changed = true;
						}
					}
				}
			}
		}
		if(next_box !== null){
			if(next_out_box){
				if(clientX >= next_box.minX || clientY <= next_box.maxY || ((next_box.minY || next_box.minY === 0) && (clientY >= next_box.minY || clientX <= next_box.right))){
					changed = true;
				}
			}else{
				if(clientX < next_box.minX || clientY > next_box.maxY || ((next_box.minY || next_box.minY === 0)  && (clientY < next_box.minY || clientX > next_box.right))){
					changed = true;
				}
			}
		}
		if(!changed) return null;
	}
	
	var node = last_target = g_eventRangeTarget;
	var offset = last_offset = g_eventRangeOffset;
	var str = node.nodeValue;

	var nodeName = (node.parentNode.nodeName).toUpperCase();
	if(nodeName == "DIV" || nodeName == "P"){
		var strLen = str.endWith(" ") ? str.length-1 : str.length;
		if(offset == strLen){
			return null;
		}
	}
	//document.getElementById('result').innerHTML = '';
	if(node === null || node.nodeType != 3 || offset === null || str.length == 0 || offset > str.length) return null;

	var g_str_prev = '', g_str_prev_test = '',g_str_next = '', g_str_next_test = '';
   	var prev_pos = null, next_pos = null;
	var prev_elm = null, next_elm = null;
	var container = node.parentNode;
	var c = newSpanNode('');
   	container.replaceChild(c, node);
	if(offset>0){
		if(offset>1){
			g_str_prev = str.substring(0,offset-1);
			c.appendChild(newTextNode(g_str_prev));
		}
		g_str_prev_test = str.substring(offset-1,offset);
    	prev_elm = newSpanNode(g_str_prev_test);
    	c.appendChild(prev_elm);
	}
	if(offset<str.length){
		g_str_next_test = str.substring(offset,offset+1);
		next_elm = newSpanNode(g_str_next_test);
    	c.appendChild(next_elm);
    	if(offset<str.length - 1){
			g_str_next = str.substring(offset+1,str.length);
			c.appendChild(newTextNode(g_str_next));
		}
	}
   	prev_out_box = false;
   	prev_box = null;
   	adjust_offset = 0;
   	if(prev_elm){
   		prev_box = {};
   		prev_pos = getOffset(prev_elm);
   		prev_box.left = prev_pos.left - 80;
   		//document.getElementById('result').innerHTML = '<br/>getoffset y='+pos.top+' x='+pos.left+' w='+pos.width+' h='+pos.height + ' X='+clientX+ ' Y='+clientY;
   		if(next_elm == null){
   			prev_box.maxX = prev_pos.left + prev_pos.width + 30;
   			prev_box.minY = prev_pos.top - 10;
   			prev_box.maxY = prev_pos.top + prev_pos.height + 30;

   			if(clientX > prev_box.maxX || clientY < prev_box.minY || clientY > prev_box.maxY || clientX < prev_box.left) prev_out_box = true;
   		}else{
   			prev_box.maxX = prev_pos.left + prev_pos.width + 50;
   			prev_box.minY = prev_pos.top - 30;
   			if(clientX > prev_box.maxX || clientY < prev_box.minY) prev_out_box = true;
   		}
   		prev_box.minX = prev_pos.left + prev_pos.width - (prev_pos.width>15?5:prev_pos.width/3);
   		if(clientX < prev_box.minX && clientX > prev_pos.left - 80){
   			g_str_next_test = g_str_prev_test + g_str_next_test;
   			g_str_prev_test = '';
   			prev_box.minX = - prev_box.minX;
   			adjust_offset = -1;
   		}
   	}
   	next_out_box = false;
   	next_box = null;
   	if(next_elm){
   		next_box = {};
   		next_pos = getOffset(next_elm);
   		next_box.right = next_pos.left + next_pos.width + 80;
   		if(prev_elm == null){
   			next_box.minX = next_pos.left - 30;
   			next_box.maxY = next_pos.top + next_pos.height + 10;
   			next_box.minY = next_pos.top - 30;
   			if(clientX < next_box.minX || clientY > next_box.maxY || clientY < next_box.minY || clientX > next_box.right) next_out_box = true;
   		}else{
   			next_box.minX = next_pos.left - 50;
   			next_box.maxY = next_pos.top + next_pos.height + 30;
   			if(clientX < next_box.minX || clientY > next_box.maxY) next_out_box = true;
   		}
   	}
   	
   	node = newTextNode(str);
   	container.replaceChild(node,c);
   	g_str_prev += g_str_prev_test;
   	g_str_next = g_str_next_test+g_str_next;
   	g_eventRangeTarget = last_target = node;

   	if(prev_out_box || next_out_box){
   		//clearHighLights();
   		// return null;
   	}

    //  document.getElementById('result').innerHTML = '<br/>getword type='+container.nodeType+' node='+container.localName+' text='+container.textContent;
    if(isHighLighter(container)){
    	node = container;
    }
    for (c = node.nextSibling; c !== null; c = c.nextSibling)
    {
		if(c.nodeType == 3){
			g_str_next += c.nodeValue;
		}else if(isHighLighter(c)){
			g_str_next += c.firstChild.nodeValue;
		}else{
			break;
		}
    }
    for (c = node.previousSibling; c !== null; c = c.previousSibling)
    {
    	if(c.nodeType == 3){
			g_str_prev = c.nodeValue + g_str_prev;
		}else if(isHighLighter(c)){
			g_str_prev = c.firstChild.nodeValue + g_str_prev;
		}else{
			break;
		}
    }
    offset = g_str_prev.length;
    str = g_str_prev + g_str_next;

  //document.getElementById('result').innerHTML += 'offset='+offset+' length='+str.length+'<br/>'+g_str_prev+'|'+g_str_next+'<br/>';

    /*range*/
    var start = offset;
    var end = offset;

    var space_cnt = 0;
    var char_cnt = 0;
    var cjk_cnt = 0;
    var eng_cnt = 0;
    var ch;
    while (start > 0 && space_cnt < 3 && char_cnt < 30 && cjk_cnt < 6) {
        ch = str.substring(start-1, start);
		if (ch == ' '){
			space_cnt ++;
			char_cnt ++;
		}else if (isCJK(ch)){
			if(eng_cnt) break;
			cjk_cnt ++;
			char_cnt += 2;
		}else if (isEng(ch)){
			if(cjk_cnt) break;
			char_cnt ++;
			eng_cnt ++;
		}else if (isEngChar(ch)){
			if(cjk_cnt) break;
			char_cnt ++;
		}else{
			break;
		}
		start--;
    }
	//document.getElementById('result').innerHTML = ' start='+start+' space='+space_cnt+' char='+char_cnt+' cjk='+cjk_cnt;
	space_cnt = 0;
	char_cnt = 0;
	eng_cnt = eng_cnt?1:0;
	cjk_cnt = cjk_cnt?1:0;
	
	while (end < str.length && space_cnt < 3 && char_cnt < 30 && cjk_cnt < 8)
	{
		ch = str.substring(end, end + 1);
		if (ch == ' '){
			space_cnt ++;
			char_cnt ++;
		}else if (isCJK(ch)){
			if(eng_cnt) break;
			cjk_cnt ++;
			char_cnt += 2;
		}else if (isEng(ch)){
			if(cjk_cnt) break;
			char_cnt ++;
			eng_cnt ++;
		}else if (isEngChar(ch)){
			if(cjk_cnt) break;
			char_cnt ++;
		}else{
			break;
		}
		end++;
	}
	if(eng_cnt + cjk_cnt == 0 || end == start) return null;
	if(start < offset){
		var char_type;
		ch = str.substring(offset-1, offset);
		if(cjk_cnt > 0){
			if(isEngChar(ch)){
				start = offset;
			}
		}else if(eng_cnt > 0 && offset < end && isEng(str.substring(offset, offset+1))){
			char_type = getCharType(str.substring(offset, offset+1));
			while( offset > start && getCharType(str.substring(offset-1, offset)) == char_type ){
				offset --;
				adjust_offset --;
			}
		}
		while(end > offset && 12 == getCharType(str.substring(offset, offset+1))){
			offset ++;
			adjust_offset ++;
		}
		if(end == offset && start < offset){
			char_type = getCharType(str.substring(offset-1, offset));
			while(char_type == 12 && start < offset){
				end --;
				offset --;
				adjust_offset --;
				char_type = getCharType(str.substring(offset-1, offset));
			}
			while(start < offset && char_type == getCharType(str.substring(offset-1, offset))){
				offset --;
				adjust_offset --;
				if(char_type > 100) break;
			}
		}
	}
	if(start == offset){
		if(cjk_cnt > 0){
			while(offset < end && getCharType(str.substring(offset, offset+1)) < 100){
				start ++;
				offset ++;
				adjust_offset ++;
			}
		}
		while(offset < end && getCharType(str.substring(offset, offset+1)) == 12){
			start ++;
			offset ++;
			adjust_offset ++;
		}
		if(start == end) return null;
		if(next_box && !next_box.minY && next_box.minY !== 0){
			next_box.minY = next_pos.top - 30;
			if( clientY < next_box.minY || clientX > next_box.right ){
				next_out_box = true;
				return null;
			}
		}
	}
	 
	
   //document.getElementById('result').innerHTML += ' end='+end+' str='+str.substring(start,end)+'<br/>';
    var ret = {prevText:str.substring(start,offset), nextText:str.substring(offset,end)};
    return ret;

}
var lastTouchTime = 1;
function OnTouchStart(e){
	
	if(e.touches.length > 1) return;
	clientX = e.touches[0].clientX;
	clientY = e.touches[0].clientY;
	
	var timeNow = new Date().getTime();
    	//document.getElementById('result').innerHTML = '<br/>s' + timeNow;
    if(timeNow - lastTouchTime < 300){
    	//document.getElementById('result').innerHTML += '<br />double'+lastTouchTime;
    	captureTextMode = true;
        lastTouchTime = 2;
 		prepareCapture(e);
 		BeginCapture();
        //captureTextMode = false;
    }else{
    	lastTouchTime = timeNow;
    }
	
	return;
}

function OnTouchMove(e){
	if(e.touches.length > 1) return;
	if (clientX == e.touches[0].clientX && clientY == e.touches[0].clientY) {
        return ;
    }
    clientX = e.touches[0].clientX;
	clientY = e.touches[0].clientY;

	if(!captureTextMode){
		return;
	}
	//document.getElementById('result').innerHTML += 'move' + lastTouchTime;
	prepareCapture(e);
	BeginCapture();
}

var g_popupDictQuery = null;

window.popupDictCall = function(jsonObj){
	if(!jsonObj || typeof jsonObj != 'object' || !jsonObj.action) return;

	
    	
	if(jsonObj.action == 'startCapture'){
		prepareCapture(null);
		captureTextMode = true;
		BeginCapture();
	}else if(jsonObj.action == 'highLight'){
		if(!captureTextMode) return;

		
		/* debug result start 
		var elm = document.getElementById('result');
		if(elm){
	    	elm.innerHTML = "<span style='background-color:yellow'>" + jasonData.prevText+'<font color=red>|</font>'+jasonData.nextText + "</span>";
			elm = elm.style;
			elm.display = 'block';
			elm.top = (clientY - 100) + 'px';
			elm.left = (clientX - 100) + 'px';
		}
		 debug result end */

		 jsonObj.prevText = jsonObj.prevText ? unescape(jsonObj.prevText) : "";
		 jsonObj.nextText = jsonObj.nextText ? unescape(jsonObj.nextText) : "";

		if(jsonObj.query){
			g_popupDictQuery = jsonObj.query;
		}else if(jsonObj.prevText || jsonObj.nextText){
			g_popupDictQuery = jsonObj.prevText + jsonObj.nextText;
		}else{
			g_popupDictQuery = null;
		}
		if(jsonObj.prevText || jsonObj.nextText){
			
			highLight(g_popupDictTarget, g_popupDictOffset, jsonObj.prevText, jsonObj.nextText);
		}else{
			clearHighLights();
		}
		if(lastTouchTime == 2){
 
		    if(g_popupDictQuery){
				  popupDict({action:'query', query:g_popupDictQuery, clientX:clientX, clientY:clientY});
				 //createMeaningPanel(); //显示弹框，写入内容
				g_popupDictQuery = null;
			}
            captureTextMode = false;
			lastTouchTime = 1;
		}
	}else if(jsonObj.action == 'stopCapture'){
		captureTextMode = false;
	    if(g_popupDictQuery){
			popupDict({action:'query', query:g_popupDictQuery, clientX:clientX, clientY:clientY});
			g_popupDictQuery = null;
		}
	}else if(jsonObj.action == 'closeDict'){
		clearHighLights();
		g_popupDictSearch = null;
	}
}


function prepareCapture(e) {
	var range = null, node = null, offset = null;
	g_eventRangeTarget = null;
	g_eventRangeOffset = null;

    if (typeof document.caretPositionFromPoint != "undefined") {
       // document.getElementById('result').innerHTML += '<br /> document.caretPositionFromPoint';
        range = document.caretPositionFromPoint(clientX, clientY);
        //document.getElementById('result').innerHTML += '<br /> range='+range;
        if(range){
	        node = range.offsetNode;
	        offset = range.offset;
	    }
    } else if (typeof document.caretRangeFromPoint != "undefined") {
        //document.getElementById('result').innerHTML += '<br /> document.caretRangeFromPoint';
        range = document.caretRangeFromPoint(clientX, clientY);
        if(range){
	        node = range.startContainer;
	        offset = range.startOffset;
	    }
    }
    // console.log(node.parentNode)
    // console.log(clickTgt)
    // console.log(node.parentNode != clickTgt)
    if(!node || node.parentNode != clickTgt) return; //限制节点点击范围，保证精确点击

	//we've bind to the body dom, so stop bubbling only affects webkit events.
	if(e && captureTextMode){
	 	e.preventDefault();
		e.stopPropagation();
	}
	
	if(!node || node.nodeType != 3) return;
	var className = node.parentNode.className;
	if(className.indexOf('moreExpBtn') != -1 || className.indexOf('foldExpBtn') != -1) return; //不取词的类名

//    document.getElementById('result').innerHTML += ' parent';

    //document.getElementById('result').innerHTML = '<br />fff='+offset+' str='+str;
	g_eventRangeTarget = node;
	g_eventRangeOffset = offset;
}


function BeginCapture() {
	//document.getElementById('result').innerHTML += '<br/>b' + (captureTextMode?' yes':' no') + lastTouchTime;

	if(! captureTextMode ) return;

    var result = null;
    try {
        result = captureWords();
    } catch(e) {
        
    }
    if (result == null) {
    	
        return;
    }

    // send
    try {
    	if( g_popupDictSearch == result.prevText + '===' + result.nextText ){
    		return;
    	}
    	//result.posX = clientX;
    	//result.posY = clientY;
    	g_popupDictTarget = g_eventRangeTarget;
    	g_popupDictOffset = g_eventRangeOffset + adjust_offset;
    	g_popupDictSearch = result.prevText + '===' + result.nextText;
    	g_popupDictQuery = null;
    	result.action = 'highLight';
    	// alert(result);
//    	result.prevText = escape(result.prevText);
//    	result.nextText = escape(result.nextText);
		popupDict(result);
        
    } catch(e) {

    }
}

function isHighLighter(node){
	return node && node.nodeType == 1 && typeof node.id == 'string' && node.id == 'highlighter' && node.childNodes.length == 1 && node.firstChild.nodeType == 3;
}

function newTextNode(str){
	return document.createTextNode(str);
}

function newSpanNode(str){
	var node = document.createElement("span");
	if(typeof str == 'string' && str.length>0) node.appendChild(newTextNode(str));
	return node;
}

function highLight(node, offset, prevText,nextText){
	//document.getElementById('result').innerHTML += '<br/>offset='+g_eventRangeOffset+' prev='+prev+' post='+post;
	if(!node || node.nodeType != 3) return;
	// alert(prevText +" / "+nextText)
	var str = node.nodeValue;
	var prev = prevText.length;
	var post = nextText.length;
	
    if(prev+post==0 || prev<0 || post<0 || str=='' || offset > str.length){
    	return;
    }
	var g_str_prev = '';
	var g_str_next = '';
	var g_str_high = '';
	if(prev>offset){
		prev -= offset;
		g_str_high = str.substring(0,offset);
	}else if(prev>0){
		g_str_high = str.substring(offset-prev,offset);
		g_str_prev = str.substring(0,offset-prev);
		prev = 0;
	}else if(offset > prev){
		g_str_prev = str.substring(0,offset-prev);
	}
	if(post>str.length - offset){
		post -= str.length - offset;
		g_str_high += str.substring(offset,str.length);
	}else if(post > 0){
		g_str_high += str.substring(offset,offset+post);
		g_str_next += str.substring(offset+post,str.length);
		post = 0;
	}else if(str.length > offset){
		g_str_next += str.substring(offset,str.length);
	}
	
    var c, newHighLighter = null;
    var container = node.parentNode;
	if(isHighLighter(container)){
		if (g_highLighter == container){
			g_highLighter = null;
		}
		newHighLighter = container;
		node = container;
		container = node.parentNode;
	}else{
		newHighLighter = newSpanNode(str);
	    newHighLighter.id = 'highlighter';
	    if(g_highLightColor) newHighLighter.style.color = g_highLightColor;
	    newHighLighter.style.cssText = "background-color:" + g_highLightBackground + ";-moz-border-radius:3px;-webkit-border-radius:3px;border-radius:3px;";
	    container.replaceChild(newHighLighter,node);
	    node = newHighLighter;
	}
	var elm = null;
	for (c = node.nextSibling; c !== null; c = c.nextSibling)
    {
		if(c.nodeType == 3){
			g_str_next += c.nodeValue;
			if(elm == null) elm = c;
			else container.removeChild(c);
		}else if(isHighLighter(c)){
			if(c == g_highLighter) g_highLighter = null;
			g_str_next += c.firstChild.nodeValue;
			if(elm == null){
				elm = c.firstChild;
				container.replaceChild(elm,c);
			}else container.removeChild(c);
		}else{
			break;
		}
    }
    if(post>0){
    	if(post>g_str_next.length) post = g_str_next.length;
    	g_str_high += g_str_next.substring(0,post);
    	g_str_next = g_str_next.substring(post,g_str_next.length);
    }
	if(elm){
		elm.nodeValue = g_str_next;
	}else{
		elm = newTextNode(g_str_next);
		if(c){
			container.insertBefore(elm,c);
		}else{
			container.appendChild(elm);
		}
	}
    elm = null;
    for (c = node.previousSibling; c !== null; c = c.previousSibling)
    {
    	if(c.nodeType == 3){
			g_str_prev = c.nodeValue + g_str_prev;
			if(elm == null) elm = c;
			else container.removeChild(c);
		}else if(isHighLighter(c)){
			if(c == g_highLighter) g_highLighter = null;
			g_str_prev = c.firstChild.nodeValue + g_str_prev;
			if(elm == null){
				elm = c.firstChild;
				container.replaceChild(elm,c);
			}else container.removeChild(c);
		}else{
			break;
		}
    }
    if(prev>0){
    	prev = g_str_prev.length - prev;
		if(prev<0) prev = 0;
		g_str_high = g_str_prev.substring(prev, g_str_prev.length) + g_str_high;
		g_str_prev = g_str_prev.substring(0,prev);
    }
    if(elm){
		elm.nodeValue = g_str_prev;
	}else{
		elm = newTextNode(g_str_prev);
		container.insertBefore(elm,node);
	}
	g_eventRangeTarget = newHighLighter.firstChild;
	g_eventRangeTarget.nodeValue = g_str_high;
	//document.getElementById('result').innerHTML += '<br/>'+container.innerHTML;

	clearHighLights();
	g_highLighter = newHighLighter;
	
	var boxSize = getOffset(g_highLighter);
	g_highLightPosX = boxSize.left + boxSize.width / 2;
	g_highLightPosY = boxSize.top + boxSize.height / 2;
}

function clearHighLights(){
	if(isHighLighter(g_highLighter)){
		var node = g_highLighter;
		var container = node.parentNode;
		if(container){
			var str = '';
			var elm = null;
			var foundNode = false;
			for (var c = container.firstChild; c !== null; c = c.nextSibling)
	        {
	        	if(c == node){
	        		str += c.firstChild.nodeValue;
	        		foundNode = true;
	        	}else if(foundNode){
	        		if(c.nodeType == 3){
	        			str += c.nodeValue;
	        			if(elm == null) elm = c;
	        		}else{
	        			break;
	        		}
	        	}else{
	        		if(c.nodeType == 3){
	        			str += c.nodeValue;
	        			if(elm == null) elm = c;
	        		}else{
	        			str = '';
	        			elm = null;
	        		}
	        	}
	        }
	        
	        if(elm == null){
	        	elm = newTextNode(str);
	        	container.insertBefore(elm,node);
	        }else{
	        	elm.nodeValue = str;
	        }
			if(g_eventRangeTarget == node){
				g_eventRangeTarget = null;
			}
			container.removeChild(node);
	        elm = elm.nextSibling;
	        while(elm != null && elm.nodeType == 3){
	        	node = elm.nextSibling;
	        	container.removeChild(elm);
	        	elm = node;
	        }
		}
		g_highLighter = null;
	}
	g_highLightPosX = null;
	g_highLightPosY = null;
}


function getWidth(el) {
    'use strict';
    var width = window.getComputedStyle(el, null).getPropertyValue('width');
    var returnWidth = parseFloat(width);
    //IE Fixes
    if (isNaN(returnWidth) || width.indexOf('%') > 0 || returnWidth < 0) {
        returnWidth = el.offsetWidth - parseFloat(window.getComputedStyle(el, null).getPropertyValue('padding-left')) - parseFloat(window.getComputedStyle(el, null).getPropertyValue('padding-right'));
    }
    return Math.ceil(returnWidth + 0.2);
}
function getHeight(el) {
    'use strict';
    var height = window.getComputedStyle(el, null).getPropertyValue('height');
    var returnHeight = parseFloat(height);
    //IE Fixes
    if (isNaN(returnHeight) || height.indexOf('%') > 0 || returnHeight < 0) {
        returnHeight = el.offsetHeight - parseFloat(window.getComputedStyle(el, null).getPropertyValue('padding-top')) - parseFloat(window.getComputedStyle(el, null).getPropertyValue('padding-bottom'));
    }
    return Math.ceil(returnHeight + 0.2);
}
function getOffset(el) {
    'use strict';
    var box = el.getBoundingClientRect();
    // var body = document.body;
    // var clientTop  = el.clientTop  || body.clientTop  || 0;
    // var clientLeft = el.clientLeft || body.clientLeft || 0;
    // var scrollTop  = window.pageYOffset || el.scrollTop;
    // var scrollLeft = window.pageXOffset || el.scrollLeft;
    // if (document.documentElement && !window.pageYOffset) {
    //     //IE7-8
    //     scrollTop  = document.documentElement.scrollTop;
    //     scrollLeft = document.documentElement.scrollLeft;
    // }
    // return {
    //     top: Math.ceil(box.top  + scrollTop  - clientTop + 0.2),
    //     left: Math.ceil(box.left + scrollLeft - clientLeft + 0.2),
    //     width: getWidth(el),
    //     height: getHeight(el)
    // };
    return {
        top: box.top,
        left: box.left,
        width: getWidth(el),
        height: getHeight(el)
    };
}

window.setHighLightColor = function(str){
	g_highLightColor = str;
}
window.setHighLightBackground = function(str){
	g_highLightBackground = str;
}

/*init*/
var $cWPopPanel;
function Init() {
	// document.addEventListener("touchstart", OnTouchStart, false);
	// document.addEventListener("touchmove", OnTouchMove, false);
	// $('#swiperBody').on('click',clickCaptureWord);
	var $body = $('body');
	$body.append('<div id="cWPopPanel"><div class="panelContent"></div><div class="arrowIcon"></div><div class="arrowIcon arrowIcon-white"></div></div>');
	$cWPopPanel = $("#cWPopPanel");
	$body.on('click',clickCaptureWord);
}

	Init();
var clickTgt;
function clickCaptureWord(e){
	if(pubArgu.showBrowserMenu) return;
	var tgt = e.target;
	clickTgt = tgt;
	if(!$(tgt).parents("#swiperBody").length && !$(tgt).closest(".main").length) return; //限制点击查词区在内容区
	clientX = e.clientX;
	clientY = e.clientY;
	
	captureTextMode = true;
    lastTouchTime = 2;
	prepareCapture(e);
	BeginCapture();
	return;
}

//显示弹框，写入内容
var xlimt = 12; //水平方向弹框限界
function createMeaningPanel(jsonData){
	$cWPopPanel.addClass("show");
	var pivot = getHighlighterPivot(highlighter);
	// var pos = highlighter.getBoundingClientRect();
	var panelWidth = $cWPopPanel.width(), panelHeight = $cWPopPanel.height();
	//确定弹窗x轴位置
	// var xpos = pos.left + pos.width / 2 - panelWidth / 2; //弹窗x坐标
	// var arrowXPos = panelWidth / 2 - 10; //箭头x坐标
	// var xMax = pubArgu.windowWidth - xlimt - panelWidth;
	// if(xpos < xlimt){
	// 	arrowXPos -= xlimt - xpos;
	// 	xpos = xlimt;
	// }
	// else if (xpos > xMax){
	// 	arrowXPos -= xMax - xpos;
	// 	xpos = xMax;
	// }
	var arrowXPos; //箭头x坐标
	//确定弹窗y轴坐标
	var ypos, yAvg = (pivot.topPoint.y + pivot.bottomPoint.y) / 2; //y轴坐标， y轴中点比例
	// console.log(yAvg)
	if(yAvg < 0.5){
		arrowXPos = pivot.bottomPoint.x * pubArgu.windowWidth - $cWPopPanel.css("left").split("px")[0] - 10; //箭头x坐标
		ypos = pivot.bottomPoint.y * pubArgu.windowHeight + 10;
		$cWPopPanel.addClass("reverse");
	}
	else {
		arrowXPos = pivot.topPoint.x * pubArgu.windowWidth - $cWPopPanel.css("left").split("px")[0] - 10; //箭头x坐标
		ypos = pivot.topPoint.y * pubArgu.windowHeight - panelHeight - 10;
	}
	$cWPopPanel.css({"top": ypos});
	$cWPopPanel.find(".arrowIcon").css({"left": arrowXPos});

	//写入内容
	$cWPopPanel.find(".panelContent").html("jfsljgiobjnlmlxvl jsjgir jvoejiboi uubudhvwe bvoedijbejo gduhbod");

	$cWPopPanel.on("touchstart", function(e){
		e.preventDefault();
	});
	//触摸即隐藏
	$(document).on("touchstart", touchHideCWPopPanel);
}

//触摸隐藏弹窗面板
function touchHideCWPopPanel(e){
	if(!$(e.target).closest("#cWPopPanel").length){ //触摸元素不在面板范围内
		$cWPopPanel.removeClass("show reverse");
		clearHighLights();
		$(document).off("touchstart", touchHideCWPopPanel); //移除监听器
	}
}

//判定选区箭头中心点
function getHighlighterPivot(highlighter){
	var lastX, newX, ttNode; //上一个位置的X坐标
	var range = document.createRange();
	var textNode = highlighter.firstChild;
	var startOffset = 0; //选区起点
	var offsetInitial = 0; //选区偏移减少值
	var topPoint = {}, bottomPoint = {}; //上下中心点

	//遍历节点, 按行归纳节点
	for(var i = 1, len = highlighter.innerHTML.length; i <= len; i++){
		//清空上一个选取节点
		if(ttNode){
			ttNode.outerHTML = ttNode.innerHTML;
            highlighter.normalize();
		}

		//创建新选取节点
		createNewSelNode(range, textNode, startOffset, i - offsetInitial, "tt");
        ttNode = highlighter.getElementsByTagName("tt")[0];
		newX = ttNode.getBoundingClientRect().right;

        if(lastX && newX <= lastX){ //如果存在旧坐标，且新坐标小于等于旧坐标，说明存在换行
        	//清除当前选取节点
        	ttNode.outerHTML = ttNode.innerHTML;
            highlighter.normalize();

            //创建被固化的节点
            createNewSelNode(range, textNode, startOffset, i - offsetInitial - 1, "gt");
            var nodeArr = highlighter.getElementsByTagName("gt");
            textNode = nodeArr[nodeArr.length - 1].nextSibling;

			//重置选区起点
			offsetInitial = i - 1;
			//创建新选取节点
			createNewSelNode(range, textNode, startOffset, i - offsetInitial, "tt");
	        ttNode = highlighter.getElementsByTagName("tt")[0];
			newX = ttNode.getBoundingClientRect().right;
        }
        lastX = newX;
	}
	ttNode.outerHTML = "<gt>" + ttNode.innerHTML + "</gt>";
	//遍历完成后，检查是否存在换行，完成定位标签创建
	var gtNodeArr = highlighter.getElementsByTagName("gt");
	if(gtNodeArr.length > 1){ //有多个gt标签，说明存在换行
		var pos = gtNodeArr[0].getBoundingClientRect();
		topPoint.x = (pos.left + pos.width / 2) / pubArgu.windowWidth;
		topPoint.y = pos.top / pubArgu.windowHeight;
		//选择后一个选区进行定位
		pos = gtNodeArr[gtNodeArr.length - 1].getBoundingClientRect();
		bottomPoint.x = (pos.left + pos.width / 2) / pubArgu.windowWidth;
		bottomPoint.y = pos.bottom / pubArgu.windowHeight;
	}
	else { //不存在换行，以当前标签为定位中心点
		var pos = gtNodeArr[0].getBoundingClientRect();
		topPoint.x = (pos.left + pos.width / 2) / pubArgu.windowWidth;
		topPoint.y = pos.top / pubArgu.windowHeight;
		bottomPoint.x = topPoint.x;
		bottomPoint.y = pos.bottom / pubArgu.windowHeight;
	}
	//清除gt选区
	do {
		var node = gtNodeArr[0];
		node.outerHTML = node.innerHTML;
	} while(gtNodeArr[0]);
	highlighter.normalize();

	return {"topPoint": topPoint, "bottomPoint": bottomPoint};
}
//创建新选取节点
function createNewSelNode(range, textNode, startOffset, endOffset, tagname){
	range.setStart(textNode, startOffset);
	range.setEnd(textNode, endOffset);
	var newTag = document.createElement(tagname);
    range.surroundContents(newTag);
}





}());
